"use strict";
/**
 * @file Ce fichier regroupe les fonctions génériques de recherche et de test utiles, mais trop puissantes pour être exportées directement.
 * @author hawkspar
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
// Toutes les entrées utilisateur sont escapées par sécurité
var ldap_escape_1 = require("ldap-escape");
// Imports internes
var config_1 = require("./config");
var basics_1 = require("./basics");
//------------------------------------------------------------------------------------------------------------------------
// Fonctions intermédiaires TBT
//------------------------------------------------------------------------------------------------------------------------
var Tools = /** @class */ (function () {
    /**
     * @memberof LDAP
     * @class Tools
     * @classdesc Cette classe contient des fonctions intermédiaires qui ne sont pas destinées à être utilisées dans les resolvers.
     * @summary Constructeur vide.
     */
    function Tools() {
    }
    /**
     * @memberof LDAP
     * @summary Fonction qui renvoit toutes les infos relatives à un groupe ou un utilisateur particulier.
     * @desc Cette fonction utilise {@link LDAP.search} avec des attributs prédéfinis. Elle est naïve et n'opère pas de récursion.
     * @param T - Format renvoyé (en pratique {@link userData} ou {@link groupData})
     * @arg {string} domain - Domaine de la recherche (utilisateur ou groupe)
     * @arg {string} id - Identifiant de la feuille cherchée (uid ou gid)
     * @return {Promise(T)} Informations recueillies ; renvoie une liste de dictionnaire avec le profil complet du groupe tel que défini par le paramètre T.
     * @static
     * @async
     */
    Tools.peek = function (domain, id, type) {
        return __awaiter(this, void 0, void 0, function () {
            var dirtyKeys, cleanData, attr, dirtyData, uncleanKey, _i, _a, cleanKey;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        dirtyKeys = config_1.ldapConfig[domain];
                        cleanData = new type();
                        attr = Object.keys(dirtyKeys).map(function (key) { return dirtyKeys[key]; });
                        return [4 /*yield*/, basics_1.Basics.searchMultiple(domain, attr, id)];
                    case 1:
                        dirtyData = (_b.sent())[0];
                        console.log(dirtyData);
                        console.log(cleanData);
                        // Rename output
                        for (uncleanKey in dirtyData) {
                            for (_i = 0, _a = Object.keys(cleanData); _i < _a.length; _i++) {
                                cleanKey = _a[_i];
                                console.log(cleanKey);
                                if (uncleanKey == dirtyKeys[cleanKey]) {
                                    cleanData[cleanKey] = dirtyData[uncleanKey];
                                }
                            }
                        }
                        return [2 /*return*/, cleanData];
                }
            });
        });
    };
    /**
     * @memberof LDAP
     * @summary Fonction qui retrouve les id des paxs ou groupes validant les critères de recherche. Etape vers vrai TOL (Trombino On Line).
     * Utiliser {@link peekUser} au cas par cas après pour obtenir les vraies infos.
     * @desc Cette fonction utilise {@link LDAP.search} mais avec un filtre généré à la volée. Accepte des champs exacts ou incomplets pour la plupart des champs
     * mais pas approximatifs et ne gère pas l'auto-complete. MEF Timeout pour des recherches trop vagues. Va crasher si un champ n'est pas dans ldapConfig.
     * @param T - Format renvoyé (en pratique {@link userData} ou {@link groupData})
     * @arg {"us"|"gr"} domain - Domaine de la recherche (utilisateur ou groupe)
     * @arg {userData | groupData} data - Dictionnaire contenant les données nécessaires à la recherche. Les valeurs sont celles entrées par l'utilisateur et sont par hypothèse
     * comme des sous-parties compactes des valeurs renvoyées. Tous les champs ci-dessous peuvent être indifféremment des listes (par exemple pour chercher un membre
     * de plusieurs groupes) ou des éléments isolés. Si un champ n'est pas pertinent, le mettre à '' ou undefined.
     * @return {Promise(string[])} ids des profils qui "match" les critères proposés.
     * @static
     * @async
     */
    Tools.search = function (domain, data) {
        return __awaiter(this, void 0, void 0, function () {
            var filter, key;
            return __generator(this, function (_a) {
                filter = "";
                // Iteration pour chaque champ, alourdissement du filtre selon des trucs prédéfinis dans ldapConfig encore
                for (key in data) {
                    if ((data[key] != undefined) && (data[key] != '')) {
                        if (!Array.isArray(data[key])) {
                            data[key] = [data[key]];
                        } // Génération systématique d'une liste de valeurs à rechercher
                        // Iteration pour chaque valeur fournie par l'utilisateur
                        data[key].forEach(function (val) {
                            // Traduction en language LDAP
                            var attribute = "";
                            attribute = config_1.ldapConfig[domain][key];
                            // Escape user input
                            val = ldap_escape_1["default"].filter("${fil}", { fil: val });
                            // Creation incrémentale du filtre
                            filter = "(&" + filter + "(|(" + attribute + "=" + val + ")" + // On cherche la valeur exacte
                                "(" + attribute + "=*" + val + ")" + // La valeur finale avec des trucs avant ; wildcard * (MEF la wildcart ne marche pas pour tous les attributs)
                                "(" + attribute + "=*" + val + "*)" + // La valeur du milieu avec des trucs avant et après
                                "(" + attribute + "=" + val + "*)))"; // La valeur du début avec des trucs après
                        });
                    }
                }
                // Appel avec filtre de l'espace 
                return [2 /*return*/, basics_1.Basics.searchSingle(domain, config_1.ldapConfig.key_id, null, filter)];
            });
        });
    };
    /**
     * @memberof LDAP
     * @summary Fonction qui édite un groupe ou utilisateur existant dans le LDAP. N'agit pas sur l'apprtenance à un groupe.
     * @desc Appelle {@link LDAP.change}.
     * @arg {"us"|"gr"} domain - Domaine de l'opération' (utilisateur ou groupe).
     * @arg {userData | groupData} data - Dictionnaire avec les nouvelles valeurs de la feuille.
     * @return {Promise(boolean)} `true` si la modification s'est bien déroulée, false sinon.
     * @async
     * @static
     */
    Tools.edit = function (domain, data) {
        return __awaiter(this, void 0, void 0, function () {
            var id, id, dirtyKeys, dirtyData;
            return __generator(this, function (_a) {
                if (domain == "user") {
                    id = data['uid'];
                }
                else {
                    id = data['gid'];
                }
                dirtyKeys = config_1.ldapConfig[domain];
                dirtyData = {};
                Object.keys(data).forEach(function (key) {
                    // Some values edit can't change
                    if (!['readPerm', 'writePerm', 'groups', 'groupsIsAdmin', 'followers', 'members', 'speakers', 'admins'].includes(key)) {
                        dirtyData[dirtyKeys.key] = data[key];
                    }
                });
                return [2 /*return*/, basics_1.Basics.change(domain, id, "replace", dirtyData)];
            });
        });
    };
    /**
     * @memberof LDAP
     * @summary Fonction qui permet d'ajouter un utilisateur à une catégorie  d'un groupe.
     * @desc Cette fonction fait essentiellement appel à d'autres fonctions de {@link Tools} passées en argument et {@link LDAP.change}.
     * Cette fonction ne créé pas de doublon et opère conjointement dans les deux arbres "group" et "user"
     * @arg {string} uid - Identifiant du futur membre
     * @arg {string} gid - Identifiant du groupe
     * @arg {"admins"|"speakers"|"members"|"followers"} category - Categorie de l'utilisateur concerné (admin, speaker, member ou follower)
     * @return {Promise(boolean)} `true` si la modification s'est bien déroulée, false sinon
     * @async
     * @static
     */
    Tools.add = function (uid, gid, category) {
        return __awaiter(this, void 0, void 0, function () {
            var lu, catName, err_1, lg, catName, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        return [4 /*yield*/, Tools.get(gid, "group", category)];
                    case 1:
                        lu = _a.sent();
                        catName = config_1.ldapConfig.group[category];
                        if (!!lu.includes(uid)) return [3 /*break*/, 3];
                        return [4 /*yield*/, basics_1.Basics.change("group", gid, "add", catName)];
                    case 2:
                        // Ajoute l'utilisateur dans la catégorie concernée
                        if (!(_a.sent())) {
                            throw "Erreur lors de la modification dans l'arbre des groupes pour ajouter un membre dans la catégorie voulue.";
                        }
                        _a.label = 3;
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        err_1 = _a.sent();
                        throw "Erreur pour obtenir une liste de membres d'une catégorie d'un groupe pour ajouter un membre de cette categorie du groupe.";
                    case 5:
                        _a.trys.push([5, 9, , 10]);
                        return [4 /*yield*/, Tools.get(uid, "user", category)];
                    case 6:
                        lg = _a.sent();
                        catName = config_1.ldapConfig.user[category];
                        if (!!lg.includes(gid)) return [3 /*break*/, 8];
                        return [4 /*yield*/, basics_1.Basics.change("user", uid, "add", catName)];
                    case 7:
                        // Ajoute l'utilisateur dans la categorie voulue
                        if (!(_a.sent())) {
                            throw "Erreur lors de l'ajout d'un utilisateur dans une catégorie d'un groupe.";
                        }
                        _a.label = 8;
                    case 8: return [2 /*return*/, true];
                    case 9:
                        err_2 = _a.sent();
                        throw "Erreur pour obtenir une liste de groupes d'une categorie d'un membre pour ajouter un groupe de cette category pour le membre.";
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @memberof LDAP
     * @summary Fonction qui permet de supprimer un membre d'une catégorie existant d'un groupe.
     * @desc Cette fonction fait essentiellement appel à d'autres fonctions de {@link Tools} passées en argument et {@link LDAP.change}.
     * @arg {string} uid - Identifiant de l'ex-membre
     * @arg {string} gid - Identifiant du groupe
     * @arg {"admins"|"speakers"|"members"|"followers"} category - Categorie de l'utilisateur concerné (admin, speaker, member ou follower)
     * @return {Promise(boolean)} `true` si la modification s'est bien déroulée, false sinon
     * @async
     * @static
     */
    Tools.remove = function (uid, gid, category) {
        return __awaiter(this, void 0, void 0, function () {
            var lu, catName, err_3, lg, catName, err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        return [4 /*yield*/, Tools.get(gid, "group", category)];
                    case 1:
                        lu = _a.sent();
                        catName = config_1.ldapConfig.group[category];
                        if (!lu.includes(uid)) return [3 /*break*/, 3];
                        return [4 /*yield*/, basics_1.Basics.change("group", gid, "del", catName)];
                    case 2:
                        // Supprime tous les utilisateurs
                        if (!(_a.sent())) {
                            throw "Erreur lors de la suppression de tous les membres d'une catégorie du groupe.";
                        }
                        // Les rajoute un par un, sauf pour le supprimé
                        lu.forEach(function (id) {
                            if (id != uid) {
                                Tools.add(id, gid, category).then(function (res) {
                                    if (!res) {
                                        throw "Erreur lors du ré-ajout d'un autre membre d'une catégorie.";
                                    }
                                });
                            }
                        });
                        _a.label = 3;
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        err_3 = _a.sent();
                        throw "Erreur pour obtenir une liste de membres d'une catégorie d'un groupe pour supprimer un membre de cette categorie du groupe.";
                    case 5:
                        _a.trys.push([5, 9, , 10]);
                        return [4 /*yield*/, Tools.get(uid, "user", category)];
                    case 6:
                        lg = _a.sent();
                        catName = config_1.ldapConfig.user[category];
                        if (!lg.includes(gid)) return [3 /*break*/, 8];
                        return [4 /*yield*/, basics_1.Basics.change("user", uid, "del", catName)];
                    case 7:
                        // Supprime tous les groupes de la catégorie pour l'utilisateur
                        if (!(_a.sent())) {
                            throw "Erreur lors de la suppression de tous les groupes d'un membre.";
                        }
                        // Les rajoute un par un, sauf pour le supprimé
                        lg.forEach(function (id) {
                            if (id != uid) {
                                Tools.add(id, gid, category).then(function (res) {
                                    if (!res) {
                                        throw "Erreur lors du ré-ajout d'un autre groupe.";
                                    }
                                });
                            }
                        });
                        _a.label = 8;
                    case 8: return [2 /*return*/, true];
                    case 9:
                        err_4 = _a.sent();
                        throw "Erreur pour obtenir une liste de groupes d'une categorie d'un membre pour supprimer un groupe de cette category pour le membre.";
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @callback changeValueCallback
     * @param {string} id - Id à modifier
     * @param {number} n - Nombre d'itérations
     * @return {string} Nouveau id
     */
    /**
     * @memberof LDAP
     * @summary Cette fonction teste une valeur d'un attribut (typiquement un identifiant) et le fait évoluer jusqu'à ce qu'il soit unique.
     * @desc Librement adapté de Stack Overflow. Appelle {@link LDAP.search} pour vérifier
     * qu'il n'y a pas d'autres occurences de cette valeur pour cette attribut
     * dans le dn fourni.
     * @param {string} value - Valeur de l'attribut (le plus souvent un identifiant) à tester à cette itération
     * @param {string} attribute - Attribut à tester
     * @param {"gr"|"us"} domain - Domaine dans lequel l'attribut doit être unique
     * @param {changeValueCallback} changeValue - Fonction qui prend uniquement en argument l'id courant et
     * le nombre d'itérations et qui renvoit la prochaine valeur de l'attribut
     * @param {number} n [0] - Nombre d'itérations (à initialiser à 0)
     * @return {Promise(string)} Valeur unique dans le domaine spécifié de l'attribut spécifié
     * @static
     * @async
     */
    Tools.ensureUnique = function (value, attribute, domain, changeValue, n) {
        if (n === void 0) { n = 0; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // Recherche d'autres occurences de l'id
                try {
                    return [2 /*return*/, basics_1.Basics.searchSingle(domain, config_1.ldapConfig.key_id, null, "(" + attribute + "=" + value + ")").then(function (matches) {
                            if (!matches) {
                                throw "";
                            }
                            else if (matches.length = 0) {
                                return value;
                            }
                            else {
                                return Tools.ensureUnique(changeValue(value, n + 1), attribute, domain, changeValue, n + 1);
                            }
                        })];
                }
                catch (err) {
                    throw "Erreur lors de la recherche d'une valeur pour assurer son unicité.";
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @memberof LDAP
     * @summary Cette fonction génère un uid standard, puis le fait évoluer jusqu'à ce qu'il soit unique.
     * @desc Limité à un appel à {@link Tools.ensureUnique} avec les bons paramètres, et quelques opérations sur l'uid pour qu'il soit valide (escape, normalisation).
     * @param {string} givenName - Prénom
     * @param {string} lastName - Nom
     * @param {string} promotion - Année de promotion
     * @return {Promise(string)} Valeur unique dans le domaine spécifié de l'attribut spécifié
     * @static
     * @async
     */
    Tools.generateUid = function (givenName, lastName, promotion) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    // normalize et lowerCase standardisent le format
                    return [2 /*return*/, Tools.ensureUnique((givenName + '.' + lastName).toLowerCase().normalize('UFD'), config_1.ldapConfig.key_id, "user", function (id, n) {
                            if (n = 1) {
                                id += '.' + promotion;
                            } // Si prénom.nom existe déjà, on rajoute la promo
                            else if (n = 2) {
                                id += '.' + (n - 1).toString();
                            } // Puis si prénom.nom.promo existe déjà on passe à nom.prenom.promo .1
                            else if (n > 2) {
                                id += n;
                            } // Ensuite on continue .123, .1234, etc...
                            return id;
                        })];
                }
                catch (err) {
                    throw "Erreur lors de l'assurance de l'unicité d'un human readable unique identifier (hruid).";
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @memberof LDAP
     * @summary Cette fonction génère un id lisible, puis le fait évoluer jusqu'à ce qu'il soit unique.
     * @desc Limité à un appel à {@link Tools.ensureUnique} avec les bons paramètres, et quelques opérations sur l'uid pour qu'il soit valide (escape, normalisation).
     * @param {string} name - Nom
     * @return {Promise(string)} Valeur unique dans le domaine spécifié de l'attribut spécifié
     * @static
     * @async
     */
    Tools.generateReadableId = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    // normalize et lowerCase standardisent le format
                    return [2 /*return*/, Tools.ensureUnique(name.toLowerCase().normalize('UFD'), config_1.ldapConfig.key_id, "group", function (id, n) {
                            if (n = 1) {
                                id += '.' + n.toString();
                            } // Si nom existe déjà, on essaie nom.1
                            else if (n > 1) {
                                id += n.toString();
                            } // Ensuite on continue .12, .123, etc...
                            return id;
                        })];
                }
                catch (err) {
                    throw "Erreur lors de l'assurance de l'unicité d'un human readable unique identifier (hruid).";
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @memberof LDAP
     * @summary Cette fonction teste une valeur dummy (0) pour un identifiant numérique puis le fait évoluer aléatoirement (entre 1 et 100 000) jusqu'à ce qu'il soit unique.
     * @param {string} attribut - Intitulé exact de l'id concerné
     * @param {"gr"|"us"} domain - Domaine dans lequel l'attribut doit être unique
     * @return {Promise(string)} Valeur unique dans le domaine spécifié de l'attribut spécifié
     * @static
     * @async
     */
    Tools.generateId = function (attribut, domain) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, Tools.ensureUnique("0", attribut, domain, function (id, n) { return Math.floor((Math.random() * 100000) + 1).toString(); })];
                }
                catch (err) {
                    throw "Erreur lors de l'assurance de l'unicité d'un unique identifier numérique.";
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @memberof LDAP
     * @summary Fonction qui retrouve les utilisateurs ou groupes respectivement correspondant à un groupe ou un utilisateur de la même catégorie.
     * @desc Cette fonction utilise {@link LDAP.search} et va directement à la feuille de l'utilisateur ou du groupe interrogé.
     * Pour autant, elle est moins naïve qu'elle en a l'air. Elle ne gère ni la descente des admins ni la remontée des membres et renvoit une réponse naïve.
     * @param {string} id - Identifiant du groupe ou de l'individu à interroger (supposé valide)
     * @param {"user"|"group"} domain - Arbre à interroger
     * @param {"admins"|"speakers"|"members"|"followers"} category - Catégorie considérée
     * @return {Promise(string[])} Liste des id de groupes ou d'utilisateurs de la bonne catégorie associé à l'id
     * @static
     * @async
     */
    Tools.get = function (id, domain, category) {
        return __awaiter(this, void 0, void 0, function () {
            var stack, res, visited, cur_id, _a, _b, _c, _d, _e, _f, err_5;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        _g.trys.push([0, 11, , 12]);
                        return [4 /*yield*/, basics_1.Basics.searchSingle(domain, config_1.ldapConfig[domain][category], id)];
                    case 1: return [2 /*return*/, _g.sent()];
                    case 2: return [2 /*return*/, _g.sent()];
                    case 3:
                        stack = [];
                        res = [];
                        visited = {};
                        stack.push(id);
                        _g.label = 4;
                    case 4:
                        if (!(stack.length > 0)) return [3 /*break*/, 10];
                        cur_id = stack.pop();
                        if (!(visited[cur_id] == undefined)) return [3 /*break*/, 9];
                        visited[cur_id] = true;
                        _b = (_a = res).concat;
                        return [4 /*yield*/, basics_1.Basics.searchSingle("group", config_1.ldapConfig.group[category], cur_id)];
                    case 5:
                        _b.apply(_a, [_g.sent()]);
                        if (!(category == "members")) return [3 /*break*/, 7];
                        _d = (_c = stack).concat;
                        return [4 /*yield*/, basics_1.Basics.searchSingle("group", config_1.ldapConfig.group.childs, cur_id)];
                    case 6:
                        _d.apply(_c, [_g.sent()]);
                        return [3 /*break*/, 9];
                    case 7:
                        _f = (_e = stack).concat;
                        return [4 /*yield*/, basics_1.Basics.searchSingle("group", config_1.ldapConfig.group.parents, cur_id)];
                    case 8:
                        _f.apply(_e, [_g.sent()]);
                        _g.label = 9;
                    case 9: return [3 /*break*/, 4];
                    case 10: return [3 /*break*/, 12];
                    case 11:
                        err_5 = _g.sent();
                        throw "Erreur lors d'une recherche générique d'un membre d'une certaine catégorie d'un groupe.";
                    case 12: return [2 /*return*/];
                }
            });
        });
    };
    return Tools;
}());
exports.Tools = Tools;
